#include "mcc_generated_files/mcc.h"

#define	MAIN_C	//{ِ̧pͯނǂݍ
#include	"main.h"
#undef	MAIN_C

#define CAP_MAX 4

typedef struct{
  uint8_t wp;
  uint16_t data[CAP_MAX];
  uint16_t avr;
}CAP_FILT;

const uint8_t dac_v[20]={0x10,0x12,0x14,0x15,0x16,0x16,0x16,0x15,0x14,0x12,0x10,
                         0x0E,0xC,0x0B,0x0A,0x0A,0x0A,0x0B,0x0C,0x0E
};

bool cmpflg = false;
uint8_t dacvalue;
CAP_FILT capbuf;

void CngDac(void);
void mainApp(void);

/* Main application */
void main(void)
{
    // initialize the device
    SYSTEM_Initialize();
    TMR0_SetInterruptHandler(CngDac);
    INTERRUPT_GlobalInterruptEnable();
    INTERRUPT_PeripheralInterruptEnable();

    while (1)
    {   
        mainApp();
    }
}
/* C */
void mainApp(void){
    
    if( capbuf.avr > 19600 && capbuf.avr < 20400 ){
       IO_RB3_SetHigh(); 
    }
    else{
        IO_RB3_SetLow();
    }    
}
/* DACɂ͋[ACg` */
void CngDac(void){
    
    DAC_SetOutput(dac_v[dacvalue]);
    if(++dacvalue >= 20){
        dacvalue = 0;
    }
}
/* Rp[^쎞̊荞 */
void IntCmp1(void){
    uint8_t i;
    uint32_t sum=0;
    
    IO_RB0_Toggle();
    TMR1_StopTimer(); //TMR1Xgbv
    capbuf.data[capbuf.wp] = TMR1_ReadTimer(); //JEgl擾
    TMR1_WriteTimer(0); //JEglNA
    TMR1_StartTimer(); //TMR1X^[g
    
    if( ++capbuf.wp >= CAP_MAX){
        capbuf.wp = 0;
    }
    
    for(i=0; i < CAP_MAX; i++){
        sum += capbuf.data[i];
    }
    capbuf.avr = (uint16_t)(sum / CAP_MAX);    
}

/* End of File */